/***************************************************************************
                          kaspaerr.h  -  description                              
                             -------------------                                         
    begin                : Mon Sep 4 2000                                           
    copyright            : (C) 2000 by Jan Mueller                         
    email                : janmueller7@hotmail.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#ifndef KASPAERR_H
#define KASPAERR_H

/**
 * @short Exception base class
 * All exception classes inherit KaspaErr. It takes a message.
 */
class KaspaErr {
 private:
  char *err;
 public:

  /** Constructor
   * @param s Error message, strdup()'ed
   */
  KaspaErr(const char *s=0);
  /** Copy constructor */
  KaspaErr(const KaspaErr& e);

  /** Destructor */
  virtual ~KaspaErr();

	KaspaErr& operator=(KaspaErr& e);

  /** Prints error message */
  virtual void print() const;
  virtual char *error() const;
};

#endif

