/***************************************************************************
                          bibtexfields.h  -  description
                             -------------------
    begin                : Sun Jan 7 2001
    copyright            : (C) 2001 by Jan Mueller
    email                : janmueller7@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          bibtexfields.h  -  description                              
                             -------------------                                         
    begin                : Sun Sep 26 1999                                           
    copyright            : (C) 1999 by Jan Mueller                         
    email                : janmueller7@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef BIBTEXFIELDS_H
#define BIBTEXFIELDS_H

#include <qwidget.h>
class PublBase;
/**
  *@author Jan Mueller
  */

class BibTexFields : public QWidget {
private:
	BibTexFields& operator=(const BibTexFields&);
	BibTexFields(const BibTexFields&);

	Q_OBJECT

public:
	BibTexFields(QWidget *w, const char *n, int i): QWidget(w,n,i) {}
	
	virtual void setWorkingGUI(bool readonly) { if(readonly) lockGUI(); else unlockGUI(); };
	virtual void setInvalidGUI() { lockGUI();   };
	virtual void setReadOnlyGUI() { lockGUI();   };
	virtual void setReadWriteGUI() { unlockGUI(); };

	void unlockGUI();
  void lockGUI();

	virtual void setFields(PublBase *publ) {};
	virtual void save(PublBase *publ) {};
};	


#endif



