/***************************************************************************
                          kaspalistboxitem.h  -  description
                             -------------------
    begin                : Sun Jan 7 2001
    copyright            : (C) 2001 by Jan Mueller
    email                : janmueller7@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KASPALISTBOXITEM_H
#define KASPALISTBOXITEM_H

#include <qlistbox.h>
#include <kaspabase.h>

/**
  *@author Jan Mueller
  */

class KaspaListBoxItem : public QListBoxText  {
	Title *t;
	
public:
  KaspaListBoxItem(QListBox *listbox, Title *title):
    QListBoxText(listbox, title->getTitle()), t(title) {
    t=new Title(*title);
  }
		
  KaspaListBoxItem(Title *title):
    QListBoxText(title->getTitle()), t(title) {
    t=new Title(*title);
  }

  KaspaListBoxItem(QListBox *listbox, Title *title, QListBoxItem *after):
    QListBoxText(listbox, title->getTitle(), after), t(title) {
    t=new Title(*title);
  }

  Title *title() { return t; }
		
	~KaspaListBoxItem() {
	  delete t;
	}
};

#endif
