/***************************************************************************
                          authorselect.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Oct 16 1999                                           
    copyright            : (C) 1999 by Jan Mueller                         
    email                : janmueller7@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "publisherselect.h"

PublisherSelect::PublisherSelect(KaspaURL url, Sql *conn, const char *caption, QWidget *parent, const char *name ) :
	Selection(parent,name, caption?caption:"Publisher") {
	_url=url;
	kaspa=new KaspaBase(conn);
	ASSERT(kaspa);
}

PublisherSelect::~PublisherSelect(){
	delete kaspa;
}

Title *PublisherSelect::getList() {
		return kaspa->getPublisherNames(_url.where());
}

bool PublisherSelect::isWorking() {
	try {
		return kaspa->isWorking();
	} catch(KaspaErr& err) {
		handleWarning(err);
		return true;
	}
}
